{******************************************************************************

襭 ⥬  ࠨ᪨ ࠢ ()
⮤  ५樨                             1.0

(c) 2002 ⠭᫠               <xstazz@hotbox.ru>

ணࠬ ࠡ             http://vt.spbgmtu.ru

******************************************************************************}

uses crt;

const
   MAX_SIZE=20;                          {ᨬ ࠧ }

type
   TMatrix= array [1..MAX_SIZE] of array [1..MAX_SIZE] of double;
   TVector= array [1..MAX_SIZE] of double;

var
   i, j: integer;
   a: TMatrix;                            { 樥⮢}
   f: TVector;                            { ࠢ }
   res: TVector;                          { 襭 ⥬}
   n: integer;                            {ࠧ୮ ⥬}
   sigma: double;                         {筮 ᫥}
   max_step: longint;                     {ᨬ쭮 ᫮ 蠣}
   data_file: text;                       {䠩 }
   result_file: text;                     {䠩 १}

{ ଠ }
function norma(var r: TVector; n: integer): double;
var
   res: double;

begin
   for i:=1 to n do begin
      res:=res+sqr(r[i]);
   end;

   norma:=sqrt(res);
end;


{஢ }
procedure copyVector(var v: TVector;
                     var r: TVector;
                     n: integer);
var
   i: integer;
begin
   for i:=1 to n do begin
      r[i]:=v[i];
   end;
end;


{ந   }
procedure multMatrixVector(var m: TMatrix;
                           var v: TVector;
                           var r: TVector;
                           n: integer);
var
   i, j: integer;
   res: double;

begin
   for i:=1 to n do begin
      res:=0;
      for j:=1 to n do begin
         res:=res+m[i,j]*v[j];
      end;
      r[i]:=res;
   end;
end;


{㬬 ஢}
procedure addVector(var v1: TVector;
                    var v2: TVector;
                    var r: TVector;
                    n: integer);
var
   i: integer;
begin
   for i:=1 to n do begin
      r[i]:=v1[i]+v2[i];
   end;
end;


{ࠧ ஢}
procedure subVector(var v1: TVector;
                    var v2: TVector;
                    var r: TVector;
                    n: integer);
var
   i: integer;
begin
   for i:=1 to n do begin
      r[i]:=v1[i]-v2[i];
   end;
end;


{襭 ⥬}
procedure linearSolveFullRelax(var a: TMatrix;      { 樥⮢}
                               var f: TVector;      { ࠢ }
                               var res: TVector;    {१}
                               n: integer;          {ࠧ୮ ⥬}
                               sigma: double);      {譮}
var
   x, r, alpha, t: TVector;
   k, max_step: longint;

begin
   k:=0;
   max_step:=10000;
   copyVector(f,x,n);

   repeat
      multMatrixVector(a,x,t,n);
      subVector(f,t,r,n);

      for i:=1 to n do begin
         alpha[i]:=r[i]/a[i,i];
      end;

      addVector(x,alpha,t,n);
      copyVector(t,x,n);

      k:=k+1;
   until (k>=max_step) or (norma(r,n)<=sigma);

   writeln('᫮ 蠣: ',k);

   if(k=max_step) then begin
      writeln(' 筮  ⨣');
   end;

   copyVector(x,res,n);
end;


begin
   sigma:=1e-7;
   max_step:=10000;

   clrscr;
   writeln('襭 ⥬  ࠨ᪨ ࠢ');
   writeln('⮤  ५樨');
   writeln;

   assign(data_file, 'a.txt');
   reset(data_file);
   read(data_file, n);

   for i:=1 to n do begin
      for j:=1 to n do begin
         read(data_file, a[i,j]);
      end;
      read(data_file, f[i]);
   end;

   close(data_file);

   writeln('७  ⥬:');
   for i:=1 to n do begin
      for j:=1 to n do begin
         write(a[i,j]:14:6);
      end;
      writeln(f[i]:14:6);
   end;
   writeln;

   linearSolveFullRelax(a,f,res,n,sigma);

   writeln(':');
   for i:=1 to n do begin
      writeln(res[i]:14:6);
   end;
   writeln;

   assign(result_file, 'result.txt');
   rewrite(result_file);

   for i:=1 to n do begin
      writeln(result_file, res[i]:14:6);
   end;

   close(result_file);

   readkey;
end.
